package prjaoadlwithcm.actions;

import java.io.File;

import java.io.IOException;
import java.util.List;

import org.eclipse.core.filesystem.EFS;
import org.eclipse.core.filesystem.IFileStore;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.MessageDialog;

import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.IWorkbenchWizard;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.ide.IDE;

import prjaoadlwithcm.atl.ATLTransformationError;
import prjaoadlwithcm.atl.ATLTransformations;

public class TransformtoThemeUML implements IObjectActionDelegate{
	
	private ISelection selection = null;
	
	//private static final String tempFile = "./transformFile.temp";
	
	private ISelection getSelection() {
		return selection;
	}
	
	@Override
	public void run(IAction action) {
		// TODO Auto-generated method stub
		
		String source = null;
		String target = null;
		String prjName = null;
		String strFileName = null;
		
		try{
			ISelection selection = getSelection();
			if (((IStructuredSelection)selection).size() > 0){
				List<?> list = ((IStructuredSelection)selection).toList();
				for(int i=0; i<list.size(); i++)
				{
					
					org.eclipse.core.internal.resources.File file1 = (org.eclipse.core.internal.resources.File)list.get(i); 
	
					source = ResourcesPlugin.getWorkspace().getRoot().getLocation().toPortableString()   +file1.getFullPath().toString();
					target = ResourcesPlugin.getWorkspace().getRoot().getLocation().toPortableString()   + file1.getProject().getFullPath().toPortableString() + "/DESIGN";
					prjName = file1.getProject().getFullPath().toPortableString();
					strFileName = file1.getFullPath().toString();
					strFileName = strFileName.substring( strFileName.lastIndexOf("/")+1, strFileName.length());
					String targetFile = transformFile(source, target, prjName, strFileName);
	
				}
			}
			
			MessageDialog.openInformation(
					null,
					"PrjAOADLwithCM",
					"Theme/UML Create successfuly.");
			
		}catch(Exception e){
			MessageDialog.openInformation(
					null,
					"PrjAOADLwithCM",
					"There was a exception at transformation to Theme/UML.");
		}
	}
	
	private String transformFile(String source, String target, String prjName, String strFileName) {

		ATLTransformations atl;

		atl = ATLTransformations.getATLTransformations();
		ATLTransformationError _error = atl.transformAOADLtoThemeUML(source, target, prjName, strFileName);

		
/*
		File file = new File(target);
		if (file.exists()) {
			file.delete();
		}

		File fileToOpen = new File(target);
		if (fileToOpen.exists() && fileToOpen.isFile()) {
			IFileStore fileStore = EFS.getLocalFileSystem().getStore(
					fileToOpen.toURI());
			IWorkbenchPage page = PlatformUI.getWorkbench()
					.getActiveWorkbenchWindow().getActivePage();

			try {
				IDE.openEditorOnFileStore(page, fileStore);
			} catch (PartInitException e) {
				// Put your exception handler here if you wish to
			}
		}*/

		return target;
	}
	
	@Override
	public void setActivePart(IAction action, IWorkbenchPart targetPart) {
		// TODO Auto-generated method stub
		
	}
	
	@Override
	public void selectionChanged(IAction action, ISelection selection) {
		this.selection = selection;
	}
}
