package prjaoadlwithcm.actions;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import org.eclipse.core.internal.runtime.InternalPlatform;
import org.eclipse.emf.cdo.CDOObject;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceImpl;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.gef.ui.actions.WorkbenchPartAction;
import org.eclipse.gmf.runtime.common.ui.util.WorkbenchPartDescriptor;
import org.eclipse.gmf.runtime.diagram.ui.resources.editor.parts.DiagramDocumentEditor;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.TreeSelection;
import org.eclipse.ui.IEditorReference;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IViewReference;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.internal.WorkbenchPartReference;
import org.eclipse.ui.part.WorkbenchPart;
import org.eclipse.uml2.diagram.clazz.part.UMLDiagramEditorPlugin;
import org.eclipse.uml2.uml.Message;

import prjaoadlwithcm.views.AOADLwithCMErrorsListing;

import aoadl.AoadlPackage;
import aoadl.Architecture;
import aoadl.Attachment;
import aoadl.BoundedRole;
import aoadl.Component;
import aoadl.ComponentInstance;
import aoadl.Connector;
import aoadl.ConnectorInstance;
import aoadl.Interface;
import aoadl.InterfaceCompositeComponent;
import aoadl.ProvidedBoundedRole;
import aoadl.ProvidedInterface;
import aoadl.diagram.part.AOADLDiagramEditor;
import aoadl.diagram.part.AOADLDiagramEditorPlugin;
import aoadl.impl.DocumentRootImpl;
import aoadl.presentation.AoadlEditor;

public class ValidateArchitecture implements IObjectActionDelegate{

	private ISelection selection = null;
	private ArrayList<String> listErros = new ArrayList<String>();
	
	private ISelection getSelection() {
		return selection;
	}
	
	@Override
	public void setActivePart(IAction action, IWorkbenchPart targetPart) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void run(IAction action) {
	
		try{
			listErros.clear();
			
			IWorkbenchPage page = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage();
			DocumentRootImpl root = null;
			
			Object[] editor = page.getEditorReferences();
			
	//		IEditorReference diagram = (IEditorReference)editor[0];
			IEditorReference diagram = (IEditorReference)page.getActivePartReference();
			//Object o = diagram.getPart(false);
			//Object o1 = page.getActivePartReference();
			
			if(diagram.getPart(false) instanceof DiagramDocumentEditor){
	
				DiagramDocumentEditor aoadlEditor = (DiagramDocumentEditor)diagram.getPart(false);
				root = (DocumentRootImpl)aoadlEditor.getDiagram().getElement();
				
				 validateArchitecture(root);
				
			}else if(diagram.getPart(false) instanceof AoadlEditor){
				AoadlEditor aoadlEditor = (AoadlEditor)diagram.getPart(false);
				
				if(((TreeSelection)aoadlEditor.getSelection()).getFirstElement() instanceof CDOObject){
					CDOObject objTree = (CDOObject)((CDOObject)((TreeSelection)aoadlEditor.getSelection()).getFirstElement()).eContainer(); 
					while(!(objTree instanceof DocumentRootImpl)){
						objTree = (CDOObject)objTree.eContainer();
					}
					root = (DocumentRootImpl)objTree;
	
				}else{
					XMIResourceImpl xmiResource = (XMIResourceImpl)((TreeSelection)aoadlEditor.getSelection()).getFirstElement();
					root = (DocumentRootImpl)xmiResource.getContents().get(0);
					
				}
				
				validateArchitecture(root);
			}
			
			String id_ = "prjaoadlwithcm.views.AOADLwithCMErrorsListing";
			
			IViewReference viewReferences[] = PlatformUI.getWorkbench()
			.getActiveWorkbenchWindow().getActivePage().getViewReferences();
			for (int i = 0; i < viewReferences.length; i++) {
				if (id_.equals(viewReferences[i].getId())) {
					((AOADLwithCMErrorsListing)viewReferences[i].getPart(false)).clearErrors();
					for(String str : listErros){
						//AOADLDiagramEditorPlugin.getInstance().logError(str);
						((AOADLwithCMErrorsListing)viewReferences[i].getPart(false)).addError(str);
					}
				}
			}
	
			
			/*for(String str : listErros){
				AOADLwithCMErrorsListing.getInstance().addError(str);
			}*/
			
			if(listErros.size() == 0){
				MessageDialog.openInformation(
						null,
						"PrjAOADLwithCM",
						"There isn't inconsistences in Architecture.");
			}
		}catch(Exception e){
			MessageDialog.openInformation(
					null,
					"PrjAOADLwithCM",
					"There was a exception at validation of architecture.");
		}
	}
	
	private void validateArchitecture(DocumentRootImpl root) {
		if(!root.isCM()){
			try{
				if(root.getInterfaceRepository() != null){
					validateInterfaces(root.getInterfaceRepository().getInterfaces());
				}
				if(root.getComponentRepository() != null){
					validateComponents(root.getComponentRepository().getComponents());
				}
				if(root.getConnectorRepository() != null){
					validateConnectors(root.getConnectorRepository().getConnectors());
				}
				if(root.getArchitectureRepository() != null){
					validateArchitectures(root.getArchitectureRepository().getArchitectures());
				}else{
					
				}
			}catch(NullPointerException e){
				
			}
		}
	}

	private boolean checkClassifier(CDOObject obj) {
		if(obj instanceof Interface){
			return ((Interface)obj).getClassifier() != null;
		}
		if(obj instanceof Component){
			return ((Component)obj).getClassifier().size() > 0;
		}
		if(obj instanceof Connector){
			return ((Connector)obj).getClassifier() != null;
		}
		
		return false;
	}

	private boolean checkName(CDOObject obj) {
		if(obj instanceof Interface){
			if(((Interface)obj).getName() == null ) return false;
			if(((Interface)obj).getName().equals("")) return false;
			return true;
		}
		if(obj instanceof Component){
			if(((Component)obj).getName() == null) return false;
			if(((Component)obj).getName().equals("")) return false;
			return true;
		}
		if(obj instanceof Connector){
			if(((Connector)obj).getName() == null) return false; 
			if(((Connector)obj).getName().equals("")) return false;
			return true;
		}
		
		if(obj instanceof Architecture){
			if(((Architecture)obj).getName() == null)  return false;
			if(((Architecture)obj).getName().equals("")) return false;
			return true;
		}
		
		if(obj instanceof InterfaceCompositeComponent){
			if(((InterfaceCompositeComponent)obj).getPortName() == null) return false;
			if(((InterfaceCompositeComponent)obj).getPortName().equals("")) return false;
			return true;
		}
		
		if(obj instanceof ComponentInstance){
			if( ((ComponentInstance)obj).getName() == null) return false;
			if(((ComponentInstance)obj).getName().equals("")) return false;
			return true;
		}
		
		if(obj instanceof BoundedRole){
			if(((BoundedRole)obj).getName() == null) return false;
			if(((BoundedRole)obj).getName().equals("")) return false;
			return true;
		}
		
		if(obj instanceof ConnectorInstance){
			if(((ConnectorInstance)obj).getName() == null) return false;
			if(((ConnectorInstance)obj).getName().equals("")) return false;
			return true;
		}
		
		return false;
	}
	
	private boolean checkInterfaceRole(InterfaceCompositeComponent inter) {
		return inter.getInterfaceRole() != null;
	}
	
	private boolean checkRole(BoundedRole role) {
		return role.getInterfaceRole() != null;
	}
	

	private boolean checkComponent(ComponentInstance comp) {
		return comp.getComponent() != null;
	}

	private boolean checkConnector(ConnectorInstance cnn) {
		return cnn.getConnector() != null;
	}
	
	private boolean checkAttachmentComponent(ComponentInstance comp) {
		return comp != null;
	}
	
	private boolean checkAttachmentConnector(ConnectorInstance cnn) {
		return cnn != null;
	}
	
	private void validateInterfaces(EList<Interface> inters) {
		for(Interface i : inters){
			if(!checkClassifier(i)){
				listErros.add("It's supposed to set a Classifier to "+i.getName()+" Interface.");
			}
			if(!checkName(i)){
				listErros.add("It's supposed to set a Name to "+i.getName()+" Interface.");
			}
		}
	}
	
	private void validateComponents(EList<Component> comps) {
		for(Component c : comps){
			
			if(!checkClassifier(c)){
				listErros.add("It's supposed to set a Classifier to "+c.getName()+" Component.");
			}
			if(!checkName(c)){
				listErros.add("It's supposed to set a Name to "+c.getName()+" Component.");
			}
			for(InterfaceCompositeComponent i : c.getInterface()){
				if(!checkName(i)){
					listErros.add("It's supposed to set a Name to "+i.getPortName()+ (i instanceof ProvidedInterface?" Provided Insterface":" Required Interface") +
							" in " +c.getName()+" Component.");
				}
				if(!checkInterfaceRole(i)){
					listErros.add("It's supposed to set the Interface Role to "+i.getPortName() +" Interface" +
							" in " +c.getName()+" Component.");
				}
				if(!checkComponentClassifierNInterface(c.getClassifier(),i)){
					listErros.add(i.getPortName()+ (i instanceof ProvidedInterface?" Provided Insterface":" Required Interface") + " couldn't be fit to any pattern " +
							" in " +c.getName()+" Component.");
				}
			}
		}
	}

	private boolean checkComponentClassifierNInterface(EList<ComponentInstance> listClass, InterfaceCompositeComponent i) {
		
		if(listClass.size() == 0){
			listErros.add(i.getPortName()+ (i instanceof ProvidedInterface?" Provided Insterface":" Required Interface") + " couldn't be fit to any pattern.");
			return true;
		}
		
		if(i.getInterfaceRole() == null){
			listErros.add("Set a interface role for " + i.getPortName()+ (i instanceof ProvidedInterface?" Provided Insterface":" Required Interface"));
			return true;
		}
		
		if(i.getInterfaceRole().getClassifier() == null){
			listErros.add("Set a classifier for " + i.getInterfaceRole()+ " Interface");
			return true;
		}
		
		ArrayList<InterfaceCompositeComponent> listInters = new ArrayList<InterfaceCompositeComponent>();
		
		for(ComponentInstance comp : listClass){
			for(InterfaceCompositeComponent inter : comp.getComponent().getInterface()){
				listInters.add(inter);
			}
		}
		
		for(InterfaceCompositeComponent inter : listInters){
			if(inter.getInterfaceRole().getName().equals(i.getInterfaceRole().getClassifier().getName())){
				return true;
			}
		}
		
		return false;
	}
	
	private void validateConnectors(EList<Connector> cnns) {
		for(Connector c : cnns){
			if(!checkClassifier(c)){
				listErros.add("It's supposed to set a Classifier to "+c.getName()+" Connector.");
			}
			if(!checkName(c)){
				listErros.add("It's supposed to set a Name to "+c.getName()+" Connector.");
			}
			for(BoundedRole r : c.getRole()){
				if(!checkName(r)){
					listErros.add("It's supposed to set a Name to "+r.getName()+ (r instanceof ProvidedBoundedRole?" Provided Role":" Required Role")+
							" in " +c.getName()+" Connector.");
				}
				if(!checkRole(r)){
					listErros.add("It's supposed to set a Role to "+r.getName()+ (r instanceof ProvidedBoundedRole?" Provided Role":" Required Role")+
							" in " +c.getName()+" Connector.");
				}
				if(!checkConnectorClassifierNRole(c.getClassifier(),r)){
					listErros.add(r.getName()+ (r instanceof ProvidedBoundedRole?" Provided Role":" Required Role") + " couldn't be fit to any pattern " +
							" in " +c.getName()+" Connector.");
				}
			}
		}
	}

	private boolean checkConnectorClassifierNRole(ConnectorInstance cnn, BoundedRole r) {
		
		if(cnn == null){
			listErros.add(r.getName()+ (r instanceof ProvidedBoundedRole?" Provided Role":" Required Role") + " couldn't be fit to any pattern.");
			return false;
		}
		
		if(r.getInterfaceRole() == null){
			listErros.add("Set a interface role for " + r.getName()+ (r instanceof ProvidedBoundedRole?" Provided Role":" Required Role"));
			return true;
		}
		
		if(r.getInterfaceRole().getClassifier() == null){
			listErros.add("Set a classifier for " + r.getInterfaceRole()+ " Interface");
			return true;
		}
		
		ArrayList<BoundedRole> listRole = new ArrayList<BoundedRole>();
		
		for(BoundedRole role : cnn.getConnector().getRole()){
			listRole.add(role);
		}
		
		for(BoundedRole role : listRole){
			if(role.getInterfaceRole().getName().equals(r.getInterfaceRole().getClassifier().getName())){
				return true;
			}
		}
		
		return false;
	}
	
	private void validateComponentInstances(EList<ComponentInstance> compInsts) {
		for(ComponentInstance c : compInsts){
			if(!checkName(c)){
				listErros.add("It's supposed to set a Name to "+c.getName()+ " Component Instance.");
			}
			if(!checkComponent(c)){
				listErros.add("It's supposed to set a Component to "+c.getName()+ " Component Instance.");
			}
		}
	}
	
	private void validateConnectorInstances(EList<ConnectorInstance> cnnInsts) {
		for(ConnectorInstance c : cnnInsts){
			if(!checkName(c)){
				listErros.add("It's supposed to set a Name to "+c.getName()+ " Connector Instance.");
			}
			if(!checkConnector(c)){
				listErros.add("It's supposed to set a Connector to "+c.getName()+ " Connector Instance.");
			}
		}
	}
	
	private void validateAttachments(EList<Attachment> atts) {
		for(Attachment a : atts){
			
			if(!checkAttachmentComponent(a.getComponent())){
				listErros.add("It's supposed to set a Component to Attachment.");
			}
			if(!checkAttachmentConnector(a.getConnector())){
				listErros.add("It's supposed to set a Connector to Attachment.");
			}
			
			if(!((a.getProvidedInterface() != null && a.getProvidedRole() != null && a.getRequiredInterface() == null && a.getRequiredRole() == null && a.getAspectualRole() == null)
				|| (a.getProvidedInterface() == null && a.getProvidedRole() == null && a.getRequiredInterface() != null && a.getRequiredRole() != null && a.getAspectualRole() == null)
				|| (a.getProvidedInterface() == null && a.getProvidedRole() == null && a.getRequiredInterface() == null && a.getRequiredRole() == null && a.getAspectualRole() != null))){
				
				listErros.add("There are inconsistences in some Attachments.");
				
				return;
			}
			
			if(a.getConnector() != null && a.getComponent() != null){
				ConnectorInstance cnnClass = a.getConnector().getConnector().getClassifier();
				EList<Attachment> attClass = cnnClass.getOwnerConnectorInstance();

				EList<ComponentInstance> compClass = a.getComponent().getComponent().getClassifier();
				boolean isfit = false;
				for(int i=0;i<attClass.size();i++){
					Attachment aClass = attClass.get(i) ;
					if(compClass.contains(aClass.getComponent())){
						if(a.getProvidedInterface() != null && a.getProvidedInterface().getInterfaceRole() != null && a.getProvidedInterface().getInterfaceRole().getClassifier() != null &&  
							aClass.getProvidedInterface() != null && aClass.getProvidedInterface().getInterfaceRole() != null && 
							a.getProvidedRole() != null && a.getProvidedRole().getInterfaceRole() != null && a.getProvidedRole().getInterfaceRole().getClassifier() != null &&  
							aClass.getProvidedRole() != null && aClass.getProvidedRole().getInterfaceRole() != null &&
							a.getProvidedInterface().getInterfaceRole().getClassifier().getName().equals(aClass.getProvidedInterface().getInterfaceRole().getName()) &&
							a.getProvidedRole().getInterfaceRole().getClassifier().getName().equals(aClass.getProvidedRole().getInterfaceRole().getName())){
								isfit = true;
								break;
						} 
						if(a.getRequiredInterface() != null && a.getRequiredInterface().getInterfaceRole() != null && a.getRequiredInterface().getInterfaceRole().getClassifier() != null &&  
							aClass.getRequiredInterface() != null && aClass.getRequiredInterface().getInterfaceRole() != null && 
							a.getRequiredRole() != null && a.getRequiredRole().getInterfaceRole() != null && a.getRequiredRole().getInterfaceRole().getClassifier() != null &&  
							aClass.getRequiredRole() != null && aClass.getRequiredRole().getInterfaceRole() != null &&
							a.getRequiredInterface().getInterfaceRole().getClassifier().getName().equals(aClass.getRequiredInterface().getInterfaceRole().getName()) &&
							a.getRequiredRole().getInterfaceRole().getClassifier().getName().equals(aClass.getRequiredRole().getInterfaceRole().getName())){
								isfit = true;
								break;
						}
					}
				}
				
				if(!isfit){
					listErros.add("There are inconsistences in Attachments between "+a.getComponent().getName()+" Component and "+a.getConnector().getName()+" Connector.");
				}
			}
		}
	}
	
	private void validateArchitectures(EList<Architecture> archs) {
		if(archs.size() == 0){
			listErros.add("It's supposed to set at least one Architecture.");
		}
		
		for(Architecture a : archs){
			if(!checkName(a)){
				listErros.add("It's supposed to set the Name to "+a.getName()+ " Architecture.");
			}
			validateComponentInstances(a.getComponentInstances());
			validateConnectorInstances(a.getConnectorInstances());
			validateAttachments(a.getAttachments());
		}
	}

	
	@Override
	public void selectionChanged(IAction action, ISelection selection) {
		this.selection = selection;		
	}

}
